## rock-master-20.06-data-processing-openann 0.20150524

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(OpenANN)

find_package(Doxygen)
find_package(OpenMP)
include(CheckIncludeFiles)
include(cmake/UseDoxygen.cmake)
include(cmake/Utilities.cmake)
include(cmake/FindEigen3.cmake)

# Check dependencies
if(NOT EIGEN3_FOUND)
  message(FATAL_ERROR "Could not find Eigen 3 library. You can either "
                      "install it with your package management system or "
                      "download it from http://eigen.tuxfamily.org/ and "
                      "install it with CMake.")
endif()
if(UNIX)
  find_program(SH_EXECUTABLE sh)
  if(NOT SH_EXECUTABLE)
    message(FATAL_ERROR "Command 'sh' is required to download required libraries.")
  endif()
  find_program(WGET_EXECUTABLE wget)
  if(NOT WGET_EXECUTABLE)
    message(FATAL_ERROR "Command 'wget' is required to download required libraries.")
  endif()
  find_program(UNZIP_EXECUTABLE unzip)
  if(NOT UNZIP_EXECUTABLE)
    message(FATAL_ERROR "Command 'unzip' is required to download required libraries.")
  endif()
else()
  message(WARNING "Only MacOS and Linux are supported!")
endif()

# Ensure out-of-source build
if(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
  message(FATAL_ERROR "Usage: mkdir build; cmake ..")
endif()

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release")
endif()

set(LOG_LEVEL "INFO" CACHE String "Log level (DEBUG, INFO, ERROR, DISABLED).")
set(PARALLEL_CORES 4 CACHE Integer "Number of cores that can be used in parallel.")

set(OPENANN_VERSION_NUMBER "1.1.0")
set(OPENANN_URL "https://github.com/OpenANN/OpenANN")
set(OPENANN_BRIEF_DESCRIPTION "An open source library for artificial neural networks.")
current_time(OPENANN_TIME)
set(OPENANN_OPTIMIZATION_FLAGS)
set(OPENANN_PYTHON_COMPILE_ARGS)
if(${CMAKE_BUILD_TYPE} STREQUAL Debug)
  message(STATUS "Debug configuration")
  if(CMAKE_COMPILER_IS_GNUCXX)
    compiler_check_add_flag("-ggdb")
    compiler_check_add_flag("-fno-default-inline")
    if(OPENMP_FOUND)
      check_cxx_compiler_flag("-fopenmp" COMPILER_SUPPORT_OPENMP)
      if(COMPILER_SUPPORT_OPENMP)
        compiler_add_flag("-fopenmp")
        compiler_add_flag("-DPARALLEL_CORES=1")
      endif()
    endif()
    compiler_add_flag("-DOPENANN_LOGLEVEL=OpenANN::Log::DEBUG")
  endif()
elseif(${CMAKE_BUILD_TYPE} STREQUAL Release)
  message(STATUS "Release configuration")
  if(CMAKE_COMPILER_IS_GNUCXX)
    compiler_check_add_flag("-g0")
    compiler_check_add_flag("-s")
    compiler_check_add_flag("-O3")
    compiler_check_add_flag("-msse")
    compiler_check_add_flag("-msse2")
    compiler_check_add_flag("-msse3")
    compiler_check_add_flag("-mssse3")
    compiler_check_add_flag("-msse4.1")
    compiler_check_add_flag("-msse4.2")
    if(OPENMP_FOUND)
      check_cxx_compiler_flag("-fopenmp" COMPILER_SUPPORT_OPENMP)
      if(COMPILER_SUPPORT_OPENMP)
        compiler_add_flag("-fopenmp")
        compiler_add_flag("-DPARALLEL_CORES=${PARALLEL_CORES}")
      endif()
    endif()
    compiler_add_flag("-DOPENANN_LOGLEVEL=OpenANN::Log::${LOG_LEVEL}")
  endif()
else()
  message(FATAL_ERROR "Unknown configuration, set CMAKE_BUILD_TYPE to Debug or Release")
endif()
set(OPENANN_COMPILER_FLAGS)
if(CMAKE_COMPILER_IS_GNUCXX)
  set(COMPILER_WARNING_FLAGS "-Wall -Wextra -pedantic -Wno-long-long -Wno-enum-compare")
endif()
set(OPENANN_LINK_LIBS "-lopenann") # libraries to link for external executables
if(OPENMP_FOUND AND CMAKE_COMPILER_IS_GNUCXX)
  set(OPENANN_LINK_LIBS "${OPENANN_LINK_LIBS} -lgomp")
endif()

set(OPENANN_COMPILER_FLAGS "${OPENANN_COMPILER_FLAGS} ${OPENANN_OPTIMIZATION_FLAGS}")
add_subdirectory(lib)

include_directories(. ${EIGEN3_INCLUDE_DIRS} lib/CMA-ESpp lib/ALGLIB test/lib/CPP-Test)
add_subdirectory(src)
option(EXCLUDE_TESTS_FROM_ALL "Exclude examples, benchmarks and test suite from standard target." ON)
if(EXCLUDE_TESTS_FROM_ALL)
  add_subdirectory(examples EXCLUDE_FROM_ALL)
  add_subdirectory(benchmarks EXCLUDE_FROM_ALL)
  add_subdirectory(test EXCLUDE_FROM_ALL)
else()
  add_subdirectory(examples)
  add_subdirectory(benchmarks)
  add_subdirectory(test)
endif()

option(BUILD_PYTHON "Build python extensions for OpenANN" ON)
if(BUILD_PYTHON)
  add_subdirectory(python)
endif()

install(DIRECTORY OpenANN DESTINATION include)

option(ALWAYS_BUILD_DOCUMENTATION "Always build OpenANN documentation using doxygen." OFF)
if(DOXYGEN_FOUND)
  if(DOXYGEN_DOT_FOUND)
    set(OPENANN_USE_DOT "YES")
  else()
    set(OPENANN_USE_DOT "NO")
  endif()
  file(MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/html)
  configure_file(doxygen.cfg.in ${PROJECT_SOURCE_DIR}/doxygen.cfg)
  if(ALWAYS_BUILD_DOCUMENTATION)
    add_documentation(openann_doc doxygen.cfg ADD_TO_ALL)
  else()
    add_documentation(openann_doc doxygen.cfg)
  endif()
  install_documentation(${PROJECT_BINARY_DIR}/html openann)
endif()

configure_file(openann.pc.in openann.pc @ONLY)
string(REPLACE ":" ";" pkg_target_search "$ENV{PKG_CONFIG_LIBDIR}")
find_path(pkg_target_dir "pkgconfig" ${pkg_target_search} "${CMAKE_INSTALL_PREFIX}/share" ${pkg_target_search})
if(NOT pkg_target_dir)
  set(pkg_target_dir "lib")
endif()
install(FILES "${PROJECT_BINARY_DIR}/openann.pc" DESTINATION "${pkg_target_dir}/pkgconfig")

set(CPACK_GENERATOR "DEB")
set(CPACK_DEBIAN_PACKAGE_MAINTAINER "Alexander Fabisch <afabisch@googlemail.com>")
set(CPACK_PACKAGE_VERSION ${OPENANN_VERSION_NUMBER})
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY ${OPENANN_BRIEF_DESCRIPTION})
SET(CPACK_DEBIAN_PACKAGE_DEPENDS "libeigen3-dev (>= 3.0.0)")
include(CPack)

=== benchmarks/CMakeLists.txt ===
add_subdirectory(mnist)
add_subdirectory(octopusarm)
add_subdirectory(p300speller)
add_subdirectory(polebalancing)
add_subdirectory(twospirals)
add_subdirectory(cifar10)
add_subdirectory(sarcos)
add_subdirectory(iris)

=== examples/CMakeLists.txt ===
add_subdirectory(polebalancing)
add_subdirectory(twospirals)
add_subdirectory(xor)
add_subdirectory(sine)

=== lib/CMakeLists.txt ===
if(NOT (IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/CMA-ESpp/"))
  if(UNIX)
    exec_program("sh" ${CMAKE_CURRENT_SOURCE_DIR} ARGS "setup.sh" "CMA-ESpp" "ALGLIB" RETURN_VALUE result)
    if(result EQUAL 1)
      message(FATAL_ERROR "I could not install CMA-ESpp.")
    elseif(result EQUAL 2)
      message(FATAL_ERROR "I could not install ALGLIB.")
    endif()
  else()
    message(FATAL_ERROR "I do not know how to install CMA-ESpp and ALGLIB.")
  endif()
endif()

set(ALGLIB_DEFINITIONS "-DAE_HAVE_STDINT")
if(CMAKE_COMPILER_IS_GNUCXX AND NOT CYGWIN_FOUND)
  set(ALGLIB_DEFINITIONS "${ALGLIB_DEFINITIONS} -w")
endif()
if(${CMAKE_SYSTEM_PROCESSOR} MATCHES "x86_64")
  set(ALGLIB_DEFINITIONS "${ALGLIB_DEFINITIONS} -DAE_CPU=1")
elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "sparc")
  set(ALGLIB_DEFINITIONS "${ALGLIB_DEFINITIONS} -DAE_CPU=2")
endif()
set(alglib_src
  ALGLIB/optimization.cpp
  ALGLIB/alglibinternal.cpp
  ALGLIB/linalg.cpp
  ALGLIB/alglibmisc.cpp
  ALGLIB/ap.cpp)
add_library(alglib SHARED ${alglib_src})
set(OPENANN_LINK_LIBS "${OPENANN_LINK_LIBS} -lalglib")
set_target_properties(alglib PROPERTIES COMPILE_FLAGS
  "${OPENANN_OPTIMIZATION_FLAGS} ${ALGLIB_DEFINITIONS}")
install(TARGETS alglib DESTINATION lib)
install(DIRECTORY ALGLIB/ DESTINATION include/alglib FILES_MATCHING PATTERN "*.h")

=== python/CMakeLists.txt ===
find_package(PythonInterp)

if(PYTHONINTERP_FOUND)
  set(PYTHONEX_LINK_LIBRARIES "\"openann\", \"alglib\"")
  if(CUDA_FOUND)
    set(PYTHONEX_LINK_LIBRARIES "${PYTHONEX_LINK_LIBRARIES}, \"openann_cuda\"")
  endif()

  file(GLOB cython_sources "*.p[xy][dix]")
  file(COPY ${cython_sources} DESTINATION .)
  configure_file(setup.py.in setup.py)

  add_custom_command(
    OUTPUT python_extension_command
    COMMAND ${CMAKE_COMMAND} -E echo "Building Python extension..."
    COMMAND ${PYTHON_EXECUTABLE} setup.py build_ext -i
    COMMAND ${CMAKE_COMMAND} -E echo "Done."
    DEPENDS ${cython_sources}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  )
  # HACK This target will only be build to test the python bindings!
  add_custom_target(python_extension DEPENDS openann alglib python_extension_command)

  add_custom_command(
    OUTPUT python_extension_install_command
    COMMAND ${CMAKE_COMMAND} -E echo "Installing Python extension..."
    COMMAND ${PYTHON_EXECUTABLE} setup.py install --prefix=${CMAKE_INSTALL_PREFIX}
    COMMAND ${CMAKE_COMMAND} -E echo "Done."
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  )
  add_custom_target(python_extension_install DEPENDS openann alglib python_extension_install_command)
  install(CODE "execute_process(COMMAND \"${CMAKE_COMMAND}\" --build . --target python_extension_install)")
else()
  message(STATUS "Could not build Python extension. You must install Python, NumPy and Cython)")
endif()

=== src/CMakeLists.txt ===
project(OpenANNLibrary)

configure_file(OpenANN.cpp.in ${PROJECT_SOURCE_DIR}/OpenANN.cpp)
add_definitions(${OPENANN_COMPILER_FLAGS})
file(GLOB_RECURSE openann_src "*.cpp")
add_library(openann SHARED ${openann_src})
if(OPENMP_FOUND)
  target_link_libraries(openann gomp)
endif()
target_link_libraries(openann alglib)
install(TARGETS openann DESTINATION lib)

=== test/CMakeLists.txt ===
add_subdirectory(lib)

find_package(Qt4)

include_directories(lib/CPP-Test)
add_definitions(${OPENANN_COMPILER_FLAGS})
file(GLOB test_src "*.cpp")

if(QT_FOUND)
  set(QT_USE_QTMAIN TRUE)
  include(${QT_USE_FILE})
  add_definitions("${QT_DEFINITIONS} -DUSE_QT")
  add_executable(TestSuite ${test_src})
  target_link_libraries(TestSuite cpptest openann ${QT_LIBRARIES})
else()
  add_executable(TestSuite ${test_src})
  target_link_libraries(TestSuite cpptest openann)
endif()

=== benchmarks/cifar10/CMakeLists.txt ===
project(CIFAR10Benchmark)

file(COPY benchmark.py DESTINATION .)

add_definitions("${OPENANN_COMPILER_FLAGS}")
add_executable(CIFAR10 cifar10.cpp)
target_link_libraries(CIFAR10 openann)

=== benchmarks/iris/CMakeLists.txt ===
project(IrisBenchmark)

file(COPY benchmark.py DESTINATION .)

=== benchmarks/mnist/CMakeLists.txt ===
project(MNISTBenchmark)

find_package(Qt4)
find_package(OpenGL)
find_package(GLUT)

file(COPY benchmark.py DESTINATION .)

check_include_files("endian.h" HAVE_ENDIAN_H)

if(HAVE_ENDIAN_H)

  add_definitions("${OPENANN_COMPILER_FLAGS}")
  add_executable(MNIST mnist.cpp)
  target_link_libraries(MNIST openann)

  if(QT_FOUND AND GLUT_FOUND AND GLUT_Xmu_LIBRARY AND NOT CYGWIN_FOUND)
    set(QT_USE_QTMAIN TRUE)
    set(QT_USE_QTOPENGL TRUE)
    include(${QT_USE_FILE})
    add_definitions("${OPENANN_COMPILER_FLAGS} ${QT_DEFINITIONS} -DUSE_QT")
    include_directories(${QT_LIB_DIR})
    add_executable(Visualize visualize.cpp)
    target_link_libraries(Visualize openann ${QT_LIBRARIES} ${GLUT_LIBRARY} ${OPENGL_LIBRARY})
    add_executable(ViewData viewdata.cpp)
    target_link_libraries(ViewData openann ${QT_LIBRARIES} ${GLUT_LIBRARY} ${OPENGL_LIBRARY})
    add_executable(RBM rbm.cpp)
    target_link_libraries(RBM openann ${QT_LIBRARIES} ${GLUT_LIBRARY} ${OPENGL_LIBRARY})
    add_executable(SAE autoencoder.cpp)
    target_link_libraries(SAE openann ${QT_LIBRARIES} ${GLUT_LIBRARY} ${OPENGL_LIBRARY})
  else()
    if(NOT QT_FOUND)
      message(WARNING "Qt4 is missing, cannot build MNIST visualization")
    endif()
    if(NOT GLUT_FOUND)
      message(WARNING "GLUT is missing, cannot build MNIST visualization")
    endif()
  endif()

else()

  message(STATUS "Could not find header 'endian.h'. Cannot compile mnist example.")

endif()

=== benchmarks/octopusarm/CMakeLists.txt ===
project(OctopusArmBenchmark)

if(UNIX)
  file(COPY benchmark.py DESTINATION .)
  file(COPY settings.xml DESTINATION .)
  add_definitions("${OPENANN_COMPILER_FLAGS}")
  add_executable(OctopusArmBenchmark agent.cpp tcpClient.cpp protocol.cpp)
  target_link_libraries(OctopusArmBenchmark openann)
endif()

=== benchmarks/p300speller/CMakeLists.txt ===
project(P300SpellerBenchmark)

file(COPY benchmark.py DESTINATION .)
add_definitions("${OPENANN_COMPILER_FLAGS}")
add_executable(P300Speller p300.cpp BCIDataSet.cpp)
target_link_libraries(P300Speller openann)

=== debian/changelog ===
rock-master-20.06-data-processing-openann (0.20150524-1~buster) unstable; urgency=low

  * Package automatically built using 'apaka'
  * repository: github:/rock-data-processing/data_processing-openann.git
  * branch: refs/heads/master
  * commit: 7b73eb76d4c5686125513f9f173f5171e8db4216
  * tag: 

 -- Rock Packaging Daemon (based on apaka) <rock-dev@dfki.de>  Mon, 07 Sep 2020 13:09:03 +0200

=== debian/control ===
Source: rock-master-20.06-data-processing-openann
Section: science
Priority: optional
Maintainer: Rock Packaging Daemon (based on apaka) <rock-dev@dfki.de>
Uploaders: Rock Packaging Daemon (based on apaka) <rock-dev@dfki.de>
Build-Depends: cdbs, debhelper (>= 8.0.0), pkg-config, dh-autoreconf, cmake, cython, doxygen, freeglut3-dev, graphviz, graphviz-dev, libeigen3-dev, libqt4-dev, libqt4-opengl-dev, libxmu-dev, python-dev, python-numpy, qt4-qmake, rock-master-20.06-base-cmake, unzip, wget
Standards-Version: 3.9.2
Homepage: http://www.rock-robotics.org

Package: rock-master-20.06-data-processing-openann
Architecture: any
Depends: ${shlibs:Depends}, cmake, cython, doxygen, freeglut3-dev, graphviz, graphviz-dev, libeigen3-dev, libqt4-dev, libqt4-opengl-dev, libxmu-dev, python-dev, python-numpy, qt4-qmake, rock-master-20.06-base-cmake, ruby, unzip, wget
Description: An open source library for artificial neural networks.
 An open source library for artificial neural networks.

=== debian/rules ===
#!/usr/bin/make -f

SHELL := /bin/bash

# BEGIN ENVIRONMENT SETUP
# https://www.debian.org/doc/debian-policy/ch-source.html
# nocheck: This tag says to not run any build-time test suite provided by the package.
DEB_BUILD_OPTIONS  = nocheck
# To disable stripping
#DEB_BUILD_OPTIONS += nostrip
export DEB_BUILD_OPTIONS

# Setup of $(arch), $(rockruby_libdir) and $(rockruby_archdir)
arch=$(shell gcc -print-multiarch)
ruby_ver=$(shell ruby -r rbconfig -e "print RbConfig::CONFIG['ruby_version']")
ruby_arch_dir=$(shell ruby -r rbconfig -e "print RbConfig::CONFIG['archdir']")
ruby_libdir=$(shell ruby -r rbconfig -e "print RbConfig::CONFIG['rubylibdir']")
rockruby_archdir=$(subst /usr,,$(ruby_arch_dir))
rockruby_libdir=$(subst /usr,,$(ruby_libdir))
# Setup of paths: PATH,PKG_CONFIG_PATH,RUBYLIB,...
master2006_install_dir = /opt/rock/master-20.06
env_setup =  PATH=$(master2006_install_dir)/bin:$$PATH
env_setup += HOME=/home/ 
env_setup += RUBYLIB=$(master2006_install_dir)/$(rockruby_libdir):$(master2006_install_dir)/$(rockruby_archdir):$(master2006_install_dir)/lib/ruby/vendor_ruby/standard:$(master2006_install_dir)/lib/ruby/vendor_ruby/core:$(master2006_install_dir)/lib/ruby/vendor_ruby:$$RUBYLIB
env_setup += PKG_CONFIG_PATH=$(master2006_install_dir)/lib/pkgconfig:$(master2006_install_dir)/lib/$(arch)/pkgconfig:/usr/share/pkgconfig:/usr/lib/$(arch)/pkgconfig:$$PKG_CONFIG_PATH
env_setup += Rock_DIR=$(master2006_install_dir)/share/rock/cmake:$$Rock_DIR
env_setup += LD_LIBRARY_PATH=$(master2006_install_dir)/lib:$(master2006_install_dir)/lib/$(arch):$$LD_LIBRARY_PATH
env_setup += CMAKE_PREFIX_PATH=$(master2006_install_dir):$$CMAKE_PREFIX_PATH
env_setup += OROGEN_PLUGIN_PATH=$(master2006_install_dir)/share/orogen/plugins:$$OROGEN_PLUGIN_PATH
export TYPELIB_CXX_LOADER=castxml
export DEB_CPPFLAGS_APPEND=-std=c++11
export npm_config_cache=/tmp/npm
rock_library_dirs=$(master2006_install_dir)/lib:$(master2006_install_dir)/lib/$(arch):
rock_base_install_dir=/opt/rock
rock_release_install_dir=/opt/rock/master-20.06
rock_install_dir=/opt/rock/master-20.06/rock-master-20.06-data-processing-openann

# Check if a python command is available and identify the version
# and identify the setup.py file
python_cmd=$(shell command -v python 2> /dev/null)
ifneq ("$(python_cmd)","")
python_version=$(shell python -c 'import sys; print "{0}.{1}".format(sys.version_info[0],sys.version_info[1])')
# Get dirname a setup.py match
python_setup_dir=$(shell find $(DEB_SRCDIR) -name setup.py | tail -n 1 | xargs dirname)
endif

DEB_VERBOSE_ALL=1
include /usr/share/cdbs/1/rules/debhelper.mk

extra_lib_dir=$(shell pwd)/debian/rock-master-20.06-data-processing-openann$(rock_install_dir)/lib
apaka_libdeps_dirs=`find $(rock_release_install_dir)/* -type d -name lib -exec echo -n ":{}" \;`
# This argument list is forwarded to dh_shlibdeps which takes the -l option and a colon separated list of libraries
# (note that this is different from the linker arguments)
DEB_DH_SHLIBDEPS_ARGS_ALL=-l$(extra_lib_dir):$(extra_lib_dir)/$(arch):$(rock_library_dirs):${apaka_libdeps_dirs}

debian_install_prefix=$(DEB_DESTDIR)$(rock_install_dir)
rock_doc_install_dir=$(rock_install_dir)/share
SOURCE_ENVSH=for file in `find $(rock_release_install_dir)/*/env.sh ! -empty -type f -name env.sh`; do source "$$file"; done;

pre-build::
	echo "Running pre-build"
	echo "Ruby stats"
	echo "   ruby version: $(ruby_ver)"
	echo "   ruby libdir: $(rockruby_libdir)"
	echo "   ruby archdir: $(rockruby_archdir)"
	# Source the available packages
	echo "Sourcing release packages' env.sh"

# END ENVIRONMENT SETUP
######################################
# BEGIN OROGEN -- This block needs to be executed before CMAKE


# END OROGEN
######################################
# BEGIN CMAKE
#
# Defining the cmake command and setting the required enviroment variables
# PKG_CONFIG_PATH Resolve Rock package via pkg-config
# Rock_DIR Set to make sure find_package(Rock) does work
# ROCK_CMAKE_MACROS Used in some patches to set the CMAKE_MODULE_PATH, allowing to find Rock.cmake
CMAKE = $(SOURCE_ENVSH) $(env_setup) cmake
DEB_CMAKE_INSTALL_PREFIX = $(rock_install_dir)

# Debian packaging discourages the use of rpath, but
# cdbs actively sets CMAKE_SKIP_RPATH=ON, so reinforcing OFF here
DEB_CMAKE_EXTRA_FLAGS = -DCMAKE_SKIP_RPATH=OFF
# Telling FindGEM.cmake to search for os packages using pkg-config and not for gems
DEB_CMAKE_EXTRA_FLAGS += -DGEM_OS_PKG=TRUE
# Leaving RUBY_EXECUTABLE unset since it maps to a path of the user executing the upload script
DEB_CMAKE_EXTRA_FLAGS += -DCMAKE_EXPORT_COMPILE_COMMANDS="ON" -DCMAKE_BUILD_TYPE="Debug" 
# Disable ROCK Testing -- since running test on the OBS would require proper setting of path, etc. (see. data_processing/type_to_vector)
DEB_CMAKE_EXTRA_FLAGS += -DROCK_TEST_ENABLED=OFF -UROCK_TEST_LOG_DIR
include /usr/share/cdbs/1/class/cmake.mk

# END CMAKE
##########################################
# BEGIN AUTOTOOLS
#


###########################################
# DOCS


# Build docs
# This checks for Doxyfile and runs doxygen with that.
# Otherwise, it tries the "doc" target.
# Since docs are not critical, ignore failures('-' on recipe line start).
# The make call is supposed to be invoked even if -t or -n is selected,
# with the appropriate flags('+' on recipe line start)

common-build-arch common-build-indep:: debian/stamp-rock-doc
debian/stamp-rock-doc:
	-+$(DEB_MAKE_INVOKE) doc
	touch $@

common-install-arch common-install-indep:: common-install-rock-doc install-extensions
common-install-rock-doc::
	mkdir -p $(DEB_DESTDIR)$(rock_doc_install_dir)
	$(if $(wildcard $(DEB_SRCDIR)/doc/html),-cp -r "$(DEB_SRCDIR)/doc/html" "$(DEB_DESTDIR)$(rock_doc_install_dir)",$(if $(wildcard $(DEB_SRCDIR)/doc),-cp -r "$(DEB_SRCDIR)/doc" "$(DEB_DESTDIR)$(rock_doc_install_dir)"))
	$(if $(wildcard $(DEB_BUILDDIR)/doc/html),-cp -r "$(DEB_BUILDDIR)/doc/html" "$(DEB_DESTDIR)$(rock_doc_install_dir)",$(if $(wildcard $(DEB_BUILDDIR)/doc),-cp -r "$(DEB_BUILDDIR)/doc" "$(DEB_DESTDIR)$(rock_doc_install_dir)"))

install-extensions:: install-python
install-python::
ifneq ("$(python_setup_dir)","")
	echo "Installing python extension in $(python_setup_dir)"
	mkdir -p $(DEB_DESTDIR)$(rock_install_dir)/lib/python$(python_version)/site-packages
	cd $(python_setup_dir); $(python_cmd) setup.py build; PYTHONPATH=$(DEB_DESTDIR)$(rock_install_dir)/lib/python$(python_version)/site-packages/ $(python_cmd) setup.py install --prefix=$(DEB_DESTDIR)$(rock_install_dir); cd -
endif

clean::
	rm -f debian/stamp-rock-doc
	rm -rf $(DEB_SRCDIR)/doc/html

# END DOCS
###########################################

define export_variable
	find $(debian_install_prefix) -type f -name '*$2' -exec dirname {} + | grep -v CMakeFiles | uniq | xargs -i printf "$1={}:\$${$1}\nexport $1\n" >> $(debian_install_prefix)/env.sh
	sed -i s#$(debian_install_prefix)#$(rock_install_dir)#g $(debian_install_prefix)/env.sh
	find $(debian_install_prefix) -type f -name '*$2' -exec dirname {} + | grep -v CMakeFiles | uniq | xargs -i printf "$1 {}\n" >> $(debian_install_prefix)/env.yml.append
	sed -i s#$(debian_install_prefix)#$(rock_install_dir)#g $(debian_install_prefix)/env.yml.append
endef

#install/rock-master-20.06-data-processing-openann::
#	echo "Running post-install for package rock-master-20.06-data-processing-openann"

# see https://github.com/Debian/cdbs/blob/master/1/rules/debhelper.mk.in for
# target
common-binary-fixup-arch::
	echo "Apaka: doing all the custom adaptions, once all patches have been applied"
	echo "Installing env.yml (and env.yml.append) in $(rock_install_dir)"
	$(if $(wildcard $(DEB_SRCDIR)/env.yml),-cp "$(DEB_SRCDIR)/env.yml" "$(DEB_DESTDIR)$(rock_install_dir)")
	$(if $(wildcard $(DEB_SRCDIR)/env.yml.append),-cp "$(DEB_SRCDIR)/env.yml.append" "$(DEB_DESTDIR)$(rock_install_dir)")
	echo "Updating env.sh in $(rock_install_dir)"
	$(if $(wildcard $(DEB_SRCDIR)/env.sh),-cp "$(DEB_SRCDIR)/env.sh" "$(debian_install_prefix)")
